User account creation filtered due to spam.

Bug 53328 - [OOP] Ambiguous check for type-bound GENERIC shall ignore PASSed arguments
Summary: [OOP] Ambiguous check for type-bound GENERIC shall ignore PASSed arguments
Status: RESOLVED FIXED
Alias: None
Product: gcc
Classification: Unclassified
Component: fortran (show other bugs)
Version: 4.8.0
: P3 normal
Target Milestone: 4.8.0
Assignee: janus
URL:
Keywords: accepts-invalid, diagnostic
Depends on:
Blocks:
 
Reported: 2012-05-11 21:29 UTC by Tobias Burnus
Modified: 2016-11-16 15:06 UTC (History)
2 users (show)

See Also:
Host:
Target:
Build:
Known to work:
Known to fail:
Last reconfirmed: 2012-06-17 00:00:00


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Tobias Burnus 2012-05-11 21:29:16 UTC
Based on a report by Rafik Zurob.

Compile the following module - and then the following:
  use m
  type(t) :: x
  call x%gen(5)
  end
Does the call invoke sub1 or sub2?


Obviously, gfortran should ignore the PASSed argument for the generic resolution of type-bound procedures, when checking for ambiguity.


The following code is invalid but accepted:

module m
  type t
  contains
    procedure, pass(this) :: sub1
    procedure, pass(this) :: sub2
    generic :: gen => sub1, sub2
  end type t
contains
  subroutine sub1(x, this)
    integer :: i
    class(t) :: this
  end subroutine sub1

  subroutine sub2 (this, y)
    integer :: i
    class(t) :: this
  end subroutine sub2
end module m
Comment 1 Tobias Burnus 2012-05-11 21:42:00 UTC
See Fortran 2003, 16.2.3 for details.

(For type-bound operators, the PASS argument itself also plays a role in distinguishing the calls - thus, it cannot completely be ignored. For type-bound generic names, I think the PASS argument should be always be indistinguishable.)
Comment 2 Tobias Burnus 2012-05-12 17:59:36 UTC
Extended examples: http://gcc.gnu.org/ml/fortran/2012-05/msg00060.html
Comment 3 janus 2012-06-17 16:40:10 UTC
Taking this one. Patch: http://gcc.gnu.org/ml/fortran/2012-06/msg00111.html
Comment 4 janus 2012-06-22 21:05:55 UTC
Author: janus
Date: Fri Jun 22 21:05:51 2012
New Revision: 188902

URL: http://gcc.gnu.org/viewcvs?root=gcc&view=rev&rev=188902
Log:
2012-06-22  Janus Weil  <janus@gcc.gnu.org>

	PR fortran/47710
	PR fortran/53328
	* interface.c (count_types_test, generic_correspondence,
	gfc_compare_interfaces): Ignore PASS arguments.
	(check_interface1, compare_parameter): Pass NULL arguments to
	gfc_compare_interfaces.
	* gfortran.h (gfc_compare_interfaces): Modified prototype.
	* expr.c (gfc_check_pointer_assign): Pass NULL arguments to
	gfc_compare_interfaces.
	* resolve.c (resolve_structure_cons): Ditto.
	(check_generic_tbp_ambiguity): Determine PASS arguments and pass them
	to gfc_compare_interfaces.


2012-06-22  Janus Weil  <janus@gcc.gnu.org>

	PR fortran/47710
	PR fortran/53328
	* gfortran.dg/typebound_generic_12.f03: New.
	* gfortran.dg/typebound_generic_13.f03: New.

Added:
    trunk/gcc/testsuite/gfortran.dg/typebound_generic_12.f03
    trunk/gcc/testsuite/gfortran.dg/typebound_generic_13.f03
Modified:
    trunk/gcc/fortran/ChangeLog
    trunk/gcc/fortran/expr.c
    trunk/gcc/fortran/gfortran.h
    trunk/gcc/fortran/interface.c
    trunk/gcc/fortran/resolve.c
    trunk/gcc/testsuite/ChangeLog
Comment 5 janus 2012-06-22 21:10:51 UTC
Fixed with r188902. Closing.